
/*****************************************************************************
 *                                                                           *
 *  PMB source code, MPI-1 part                           ---/---            *
 *                                                          / /              *
 *  Copyright (c) PALLAS GmbH 1998                         / / /             *
 *                                                        / / / /            *
 *                                                         / / /             *
 *  Authors: Hans-Joachim Plum , Gero Ritzenhoefer          / / PALLAS       *
 *  Revision: 2.0                                         ---/---            *
 *  Date: 1998/03/10                                                         *
 *                                                                           *
 *****************************************************************************/
#ifndef _SETTINGS_H
#define _SETTINGS_H

/*   Message sizes in Bytes: 0,2**MINMSGLOG,...,2**MAXMSGLOG
     respectively nearest multiples of basic datatype */
#define MINMSGLOG 0
#define MAXMSGLOG 20 

/*   define MSGSPERSAMPLE = Maximium number of messages per sample  
     define TOTALSIZE = Maximun overall message size per sample       
     Number of sample messages is       
     min( MSGPERSAMPLE, 1+TOTALSIZE/<message size> */
#define MSGSPERSAMPLE 1000
#define TOTALSIZE 40*1048576

/*   define N_WARMUP = number of iterations of the current benchmark
     (with maximun message length) BEFORE time measuring begins
     N_BARR          = number of BARRIER synchronizations 
     before each experiment */
#define N_WARMUP 2
#define N_BARR   2


/*   Filename for results output; insert empty string for stdout */
#define OUTPUT_FILENAME  "bench.out"


/*   RESCALING OF TIME (SCALE =10^3 => m sec)
     (SCALE =10^6 => u sec)*/
#define SCALE 1000000

/*   WIDTH OF OUTPUT TABLE */
#define ow_format 13

#define min(a,b) (a)<(b)?(a):(b)
#define max(a,b) (a)>(b)?(a):(b)

/* How to set communications buffers for process rank, index i */

#define BUF_VALUE(rank,i)  (0.1*((rank)+1)+(float)((i)%((rank)+2)))

#endif
